package com.hotwj.platform.resourceManagement.company.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.resourceManagement.company.domain.HotCompanyBankAccount;
import com.hotwj.platform.resourceManagement.company.domain.bo.HotCompanyBankAccountBo;
import com.hotwj.platform.resourceManagement.company.domain.vo.HotCompanyBankAccountVo;
import com.hotwj.platform.resourceManagement.company.mapper.HotCompanyBankAccountMapper;
import com.hotwj.platform.resourceManagement.company.service.IHotCompanyBankAccountService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 公司银行账户Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-08
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotCompanyBankAccountServiceImpl implements IHotCompanyBankAccountService {

    private final HotCompanyBankAccountMapper baseMapper;

    /**
     * 查询公司银行账户
     *
     * @param id 主键
     * @return 公司银行账户
     */
    @Override
    public HotCompanyBankAccountVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询公司银行账户列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 公司银行账户分页列表
     */
    @Override
    public TableDataInfo<HotCompanyBankAccountVo> queryPageList(HotCompanyBankAccountBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotCompanyBankAccount> lqw = buildQueryWrapper(bo);
        Page<HotCompanyBankAccountVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的公司银行账户列表
     *
     * @param bo 查询条件
     * @return 公司银行账户列表
     */
    @Override
    public List<HotCompanyBankAccountVo> queryList(HotCompanyBankAccountBo bo) {
        LambdaQueryWrapper<HotCompanyBankAccount> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotCompanyBankAccount> buildQueryWrapper(HotCompanyBankAccountBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotCompanyBankAccount> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotCompanyBankAccount::getId);
        lqw.eq(bo.getCompanyId() != null, HotCompanyBankAccount::getCompanyId, bo.getCompanyId());
        lqw.eq(StringUtils.isNotBlank(bo.getAccountNumber()), HotCompanyBankAccount::getAccountNumber, bo.getAccountNumber());
        lqw.eq(StringUtils.isNotBlank(bo.getBankType()), HotCompanyBankAccount::getBankType, bo.getBankType());
        lqw.eq(StringUtils.isNotBlank(bo.getBankBranch()), HotCompanyBankAccount::getBankBranch, bo.getBankBranch());
        lqw.eq(bo.getIsDeleted() != null, HotCompanyBankAccount::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增公司银行账户
     *
     * @param bo 公司银行账户
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotCompanyBankAccountBo bo) {
        HotCompanyBankAccount add = MapstructUtils.convert(bo, HotCompanyBankAccount.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改公司银行账户
     *
     * @param bo 公司银行账户
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotCompanyBankAccountBo bo) {
        HotCompanyBankAccount update = MapstructUtils.convert(bo, HotCompanyBankAccount.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotCompanyBankAccount entity) {
    }

    /**
     * 校验并批量删除公司银行账户信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
